/* tslint:disable */
class ProxyIdentifier {
  static count = 0;
  _proxyIdentifierBrand;
  _suppressCompilerUnusedWarning;
  isMain;
  sid;
  nid;
  hostId;
  constructor(isMain, sid, hostId) {
    this.isMain = isMain;
    this.sid = sid;
    this.nid = ++ProxyIdentifier.count;
    this.hostId = hostId;
  }
}
const identifiers = [];
function createMainContextProxyIdentifier(identifier, hostIdentifier = 1 /* HostIdentifier.ServerMainThread */) {
  const result = new ProxyIdentifier(true, identifier, hostIdentifier);
  identifiers[result.nid] = result;
  return result;
}
function createExtHostContextProxyIdentifier(identifier, hostIdentifier = 0 /* HostIdentifier.ServerExtHost */) {
  const result = new ProxyIdentifier(false, identifier, hostIdentifier);
  identifiers[result.nid] = result;
  return result;
}
function getStringIdentifierForProxy(nid) {
  return identifiers[nid] ? identifiers[nid].sid : null;
}
var HostIdentifier;
(function (HostIdentifier) {
  HostIdentifier[HostIdentifier["ServerExtHost"] = 0] = "ServerExtHost";
  HostIdentifier[HostIdentifier["ServerMainThread"] = 1] = "ServerMainThread";
  HostIdentifier[HostIdentifier["BrowserExtHost"] = 2] = "BrowserExtHost";
  HostIdentifier[HostIdentifier["BrowserClientThread"] = 3] = "BrowserClientThread";
})(HostIdentifier || (HostIdentifier = {}));
var RequestType;
(function (RequestType) {
  /**
   * Process the request on the reciever end
   */
  RequestType[RequestType["Process"] = 0] = "Process";
  /**
   * Forward the requests to the other end.
   */
  RequestType[RequestType["Forward"] = 1] = "Forward";
  /**
   * Process the request and reply with Forward bit.
   */
  RequestType[RequestType["ProcessAndForward"] = 2] = "ProcessAndForward";
})(RequestType || (RequestType = {}));
var TransportType;
(function (TransportType) {
  TransportType[TransportType["Socket"] = 0] = "Socket";
  TransportType[TransportType["WebSocket"] = 1] = "WebSocket";
})(TransportType || (TransportType = {}));export{HostIdentifier,ProxyIdentifier,RequestType,TransportType,createExtHostContextProxyIdentifier,createMainContextProxyIdentifier,getStringIdentifierForProxy};//# sourceMappingURL=proxy-identifier.js.map
